#include <stdio.h>

void foo(int a) {
    a += 3;
}

void bar(int *a) {
    *a += 3;
}

void baz(int *a) {
    a += 3;
}

int main() {
    int a = 5;
    printf("%i\n", a);

    // la fonction foo ne peut pas modifier son parametre
    // c'est donc normal que a ne soit pas modifié
    foo(a);
    printf("%i\n", a);
    
    // la fonction bar prend un pointeur sur a
    // ce qui lui permet de modifier a
    bar(&a);
    printf("%i\n", a);
    
    // la fonction baz pourrait modifier a
    // mais son code modifie uniquement son pointeur 
    // en interne de la fonction
    baz(&a);
    printf("%i\n", a);
}